package com.sencorsta.rabs.obj.ai.scene.energy;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;
import com.sencorsta.rabs.util.ResettableData;

import java.awt.AWTException;

/**
 * 体力领取-领取
 */
@SceneAnnotation("SceneMain_Energy")
public class SceneMain_Energy_Free extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 4.0f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\energy\\free\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\energy\\free\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\energy\\free\\back.png";

    private static String PathTake = System.getProperty("user.dir") + "\\opencv\\scene\\energy\\free\\take.png";


    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(2000);
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() throws AWTException {
        moveToClick(PathTake,AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        getRecord().getData().setDone(true);
    }

    @Override
    public boolean isDone() {
        return getRecord().getData().isDone();
    }

    /**
     * 重置
     */
    @Override
    public ResettableData.ResetType getType(){
        return ResettableData.ResetType.SPECIAL_RULES;
    };

}
